/* SCCSID: inc/cssmdlattribute.h, dss_cdsa_fwk, fwk_rel3, dss_980403 1.3 4/13/98 10:40:14 */
/* ***************************************************************** *
 * Copyright 1998 International Business Machines Corporation. All   *
 * Rights Reserved.                                                  *
 *                                                                   *
 * Please read this carefully.  Your use of this reference           *
 * implementation of certain of the IETF public-key infrastructure   *
 * specifications ("Software") indicates your acceptance of the      *
 * following.  If you do not agree to the following, do not install  *
 * or use any of the Software.                                       *
 *                                                                   *
 * Permission to use, reproduce, distribute and create derivative    *
 * works from the Software ("Software Derivative Works"), and to     *
 * distribute such Software Derivative Works is hereby granted to    *
 * you by International Business Machines Corporation ("IBM").  This *
 * permission includes a license under the patents of IBM that are   *
 * necessarily infringed by your use of the Software as provided by  *
 * IBM.                                                              *
 *                                                                   *
 * IBM licenses the Software to you on an "AS IS" basis, without     *
 * warranty of any kind.  IBM HEREBY EXPRESSLY DISCLAIMS ALL         *
 * WARRANTIES OR CONDITIONS, EITHER EXPRESS OR IMPLIED, INCLUDING,   *
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR CONDITIONS OF       *
 * MERCHANTABILITY, NON INFRINGEMENT AND FITNESS FOR A PARTICULAR    *
 * PURPOSE.  You are solely responsible for determining the          *
 * appropriateness of using this Software and assume all risks       *
 * associated with the use of this Software, including but not       *
 * limited to the risks of program errors, damage to or loss of      *
 * data, programs or equipment, and unavailability or interruption   *
 * of operations.                                                    *
 *                                                                   *
 * IBM WILL NOT BE LIABLE FOR ANY DIRECT DAMAGES OR FOR ANY SPECIAL, *
 * INCIDENTAL, OR  INDIRECT DAMAGES OR FOR ANY ECONOMIC              *
 * CONSEQUENTIAL DAMAGES (INCLUDING LOST PROFITS OR SAVINGS), EVEN   *
 * IF IBM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.  IBM  *
 * will not be liable for the loss of, or damage to, your records or *
 * data, or any damages claimed by you based on a third party claim. *
 *                                                                   *
 * IBM wishes to obtain your feedback to assist in improving the     *
 * Software.  You grant IBM a world-wide, royalty-free right to use, *
 * copy, distribute, sublicense and prepare derivative works based   *
 * upon any feedback, including materials, error corrections,        *
 * Software Derivatives, enhancements, suggestions and the like that *
 * you provide to IBM relating to the Software (this does not        *
 * include products for which you charge a royalty and distribute to *
 * IBM under other terms and conditions).                            *
 *                                                                   *
 * You agree to distribute the Software and any Software Derivatives *
 * under a license agreement that: 1) is sufficient to notify all    *
 * licensees of the Software and Software Derivatives that IBM       *
 * assumes no liability for any claim that may arise regarding the   *
 * Software or Software Derivatives, and 2) that disclaims all       *
 * warranties, both express and implied, from IBM regarding the      *
 * Software and Software Derivatives.  (If you include this          *
 * Agreement with any distribution of the Software or Software       *
 * Derivatives you will have met this requirement.)  You agree that  *
 * you will not delete any copyright notices in the Software.        *
 *                                                                   *
 * This Agreement is the exclusive statement of your rights in the   *
 * Software as provided by IBM.   Except for the rights granted to   *
 * you in the second paragraph above, You are not granted any other  *
 * patent rights, including but not limited to the right to make     *
 * combinations of the Software with products that infringe IBM      *
 * patents. You agree to comply with all applicable laws and         *
 * regulations, including all export and import laws and regulation. *
 * This Agreement is governed by the laws of the State of New York.  *
 * This Agreement supersedes all other communications,               *
 * understandings or agreements we may have had prior to this        *
 * Agreement.                                                        *
 * ***************************************************************** */

/*
 * (C) COPYRIGHT International Business Machines Corp. 1996, 1997
 * All Rights Reserved
 * Licensed Materials - Property of IBM
 *
 * Copyright (c) 1995, 1996, 1997 Intel Corporation. All rights reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 */

#ifndef _CSSMDLATTRIBUTE_H_
#define _CSSMDLATTRIBUTE_H_

#define CSSM_DL_ATTRIBUTE_CLASS              0x00000000
#define CSSM_DL_ATTRIBUTE_TOKEN              0x00000001
#define CSSM_DL_ATTRIBUTE_PRIVATE            0x00000002
#define CSSM_DL_ATTRIBUTE_LABEL              0x00000003
#define CSSM_DL_ATTRIBUTE_APPLICATION        0x00000010
#define CSSM_DL_ATTRIBUTE_VALUE              0x00000011
#define CSSM_DL_ATTRIBUTE_CERTIFICATE_TYPE   0x00000080
#define CSSM_DL_ATTRIBUTE_ISSUER             0x00000081
#define CSSM_DL_ATTRIBUTE_SERIAL_NUMBER      0x00000082
#define CSSM_DL_ATTRIBUTE_KEY_TYPE           0x00000100
#define CSSM_DL_ATTRIBUTE_SUBJECT            0x00000101
#define CSSM_DL_ATTRIBUTE_ID                 0x00000102
#define CSSM_DL_ATTRIBUTE_SENSITIVE          0x00000103
#define CSSM_DL_ATTRIBUTE_ENCRYPT            0x00000104
#define CSSM_DL_ATTRIBUTE_DECRYPT            0x00000105
#define CSSM_DL_ATTRIBUTE_WRAP               0x00000106
#define CSSM_DL_ATTRIBUTE_UNWRAP             0x00000107
#define CSSM_DL_ATTRIBUTE_SIGN               0x00000108
#define CSSM_DL_ATTRIBUTE_SIGN_RECOVER       0x00000109
#define CSSM_DL_ATTRIBUTE_VERIFY             0x0000010A
#define CSSM_DL_ATTRIBUTE_VERIFY_RECOVER     0x0000010B
#define CSSM_DL_ATTRIBUTE_DERIVE             0x0000010C
#define CSSM_DL_ATTRIBUTE_START_DATE         0x00000110
#define CSSM_DL_ATTRIBUTE_END_DATE           0x00000111
#define CSSM_DL_ATTRIBUTE_MODULUS            0x00000120
#define CSSM_DL_ATTRIBUTE_MODULUS_BITS       0x00000121
#define CSSM_DL_ATTRIBUTE_PUBLIC_EXPONENT    0x00000122
#define CSSM_DL_ATTRIBUTE_PRIVATE_EXPONENT   0x00000123
#define CSSM_DL_ATTRIBUTE_PRIME_1            0x00000124
#define CSSM_DL_ATTRIBUTE_PRIME_2            0x00000125
#define CSSM_DL_ATTRIBUTE_EXPONENT_1         0x00000126
#define CSSM_DL_ATTRIBUTE_EXPONENT_2         0x00000127
#define CSSM_DL_ATTRIBUTE_COEFFICIENT        0x00000128
#define CSSM_DL_ATTRIBUTE_PRIME              0x00000130
#define CSSM_DL_ATTRIBUTE_SUBPRIME           0x00000131
#define CSSM_DL_ATTRIBUTE_BASE               0x00000132
#define CSSM_DL_ATTRIBUTE_VALUE_BITS         0x00000160
#define CSSM_DL_ATTRIBUTE_VALUE_LEN          0x00000161
#define CSSM_DL_ATTRIBUTE_EXTRACTABLE        0x00000162
#define CSSM_DL_ATTRIBUTE_LOCAL              0x00000163
#define CSSM_DL_ATTRIBUTE_NEVER_EXTRACTABLE  0x00000164
#define CSSM_DL_ATTRIBUTE_ALWAYS_SENSITIVE   0x00000165
#define CSSM_DL_ATTRIBUTE_MODIFIABLE         0x00000170

#define CSSM_DL_ATTRIBUTE_VENDOR_DEFINED     0x80000000

typedef enum _CSSM_DL_DB_ATTRIBUTE_CLASS {
	CSSM_ATTRIBUTE_DBOBJECTCLASS_PUBLIC_KEY,
	CSSM_ATTRIBUTE_DBOBJECTCLASS_PRIVATE_KEY,
	CSSM_ATTRIBUTE_DBOBJECTCLASS_SESSION_KEY,
	CSSM_ATTRIBUTE_DBOBJECTCLASS_CERTIFICATE
} CSSM_DL_DB_ATTRIBUTE_CLASS;


typedef enum _CSSM_DL_DB_ATTRIBUTES_KEYTYPE {
	CSSM_ATTRIBUTE_KEYTYPE_RSA,
	CSSM_ATTRIBUTE_KEYTYPE_DSA,
	CSSM_ATTRIBUTE_KEYTYPE_DES,
	CSSM_ATTRIBUTE_KEYTYPE_DES2,
	CSSM_ATTRIBUTE_KEYTYPE_DES3,
	CSSM_ATTRIBUTE_KEYTYPE_RC2,
	CSSM_ATTRIBUTE_KEYTYPE_RC4
} CSSM_DL_DB_ATTRIBUTES_KEYTYPE;


#endif	/* _CSSMDLATTRIBUTE_H_ */
